/* A lexical scanner generated by flex */

/* scanner skeleton version:
 * $Header: /usr/fsys/odin/a/vern/flex/RCS/flex.skel,v 2.16 90/08/03 14:09:36 vern Exp $
 */

#define FLEX_SCANNER

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <osfcn.h>

/* use prototypes in function declarations */
#define YY_USE_PROTOS

/* the "const" storage-class-modifier is valid */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#ifdef __GNUC__
#include <stddef.h>
void *malloc( size_t );
void free( void* );
#else
#include <stdlib.h>
#endif	/* __GNUC__ */

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */


#ifdef __TURBOC__
#define YY_USE_CONST
#endif


#ifndef YY_USE_CONST
#define const
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
/* we can't get here if it's an ANSI C compiler, or a C++ compiler,
 * so it's got to be a K&R compiler, and therefore there's no standard
 * place from which to include these definitions
 */
char *malloc();
int free();
int read();
#endif


/* amount of stuff to slurp up with each read */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* returned upon end-of-file */
#define YY_END_TOK 0

/* copy whatever the last rule matched to the standard output */

/* cast to (char *) is because for 8-bit chars, cord_text is (unsigned char *) */
/* this used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite()
 */
#define ECHO (void) fwrite( (char *) cord_text, cord_leng, 1, cord_out )

/* gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#define YY_INPUT(buf,result,max_size) \
	if ( (result = read( fileno(cord_in), (char *) buf, max_size )) < 0 ) \
	    YY_FATAL_ERROR( "read() in flex scanner failed" );
#define YY_NULL 0

/* no semi-colon after return; correct usage is to write "cord_terminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#define cord_terminate() return ( YY_NULL )

/* report a fatal error */

/* The funky do-while is used to turn this macro definition into
 * a single C statement (which needs a semi-colon terminator).
 * This avoids problems with code like:
 *
 * 	if ( something_happens )
 *		YY_FATAL_ERROR( "oops, the something happened" );
 *	else
 *		everything_okay();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the YY_FATAL_ERROR() call.
 */

#define YY_FATAL_ERROR(msg) \
	do \
		{ \
		(void) fputs( msg, stderr ); \
		(void) putc( '\n', stderr ); \
		exit( 1 ); \
		} \
	while ( 0 )

/* default cord_wrap function - always treat EOF as an EOF */
#define cord_wrap() 1

/* enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN
 */
#define BEGIN cord__start = 1 + 2 *

/* action number for EOF rule of a given start state */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* special action meaning "start processing a new file" */
#define YY_NEW_FILE \
	do \
		{ \
		cord__init_buffer( cord__current_buffer, cord_in ); \
		cord__load_buffer_state(); \
		} \
	while ( 0 )

/* default declaration of generated scanner - a define so the user can
 * easily add parameters
 */
#define YY_DECL int cord_lex YY_PROTO(( void )) 

/* code executed at the end of each rule */
#define YY_BREAK break;

#define YY_END_OF_BUFFER_CHAR 0

#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE (YY_READ_BUF_SIZE * 2) /* size of default input buffer */
#endif

typedef struct cord__buffer_state *YY_BUFFER_STATE;

#define YY_CHAR char
# line 1 "lexer.l"
#define INITIAL 0
# line 2 "lexer.l"
/*
    This file is part of the FElt finite element analysis package.
    Copyright (C) 1993,1994 Jason I. Gobat and Darren C. Atkinson

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/************************************************************************
 * File:	lexer.l							*
 *									*
 * Description:	This file contains the flex specification for the	*
 *		input file lexical analyzer.				*
 *									*
 * History:	V1.0 by Jason Gobat and Darren C. Atkinson		*
 ************************************************************************/

# include <stdlib.h>
# include <string.h>
# include "generator.h"
# include "error.h"
# include "y.tab.h"


/************************************************************************
 * Function:	 cord_lex							*
 *									*
 * Parameters:	 none							*
 *									*
 * Return value: next token						*
 *									*
 * Calls:	 none							*
 *									*
 * Called by:	 cord_parse						*
 *									*
 * Global data:	 cord_text is modified					*
 *									*
 * Description:	 Yylex is the input file lexical analyzer generated	*
 *		 by flex.						*
 ************************************************************************/

# line 67 "lexer.l"

/* done after the current pattern has been matched and before the
 * corresponding action - sets up cord_text
 */
#define YY_DO_BEFORE_ACTION \
	cord_text = cord__bp; \
	cord_leng = cord__cp - cord__bp; \
	cord__hold_char = *cord__cp; \
	*cord__cp = '\0'; \
	cord__c_buf_p = cord__cp;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* return all but the first 'n' matched characters back to the input stream */
#define cord_less(n) \
	do \
		{ \
		/* undo effects of setting up cord_text */ \
		*cord__cp = cord__hold_char; \
		cord__c_buf_p = cord__cp = cord__bp + n; \
		YY_DO_BEFORE_ACTION; /* set up cord_text again */ \
		} \
	while ( 0 )

#define unput(c) cord_unput( c, cord_text )


struct cord__buffer_state
    {
    FILE *cord__input_file;

    YY_CHAR *cord__ch_buf;		/* input buffer */
    YY_CHAR *cord__buf_pos;	/* current position in input buffer */

    /* size of input buffer in bytes, not including room for EOB characters*/
    int cord__buf_size;	

    /* number of characters read into cord__ch_buf, not including EOB characters */
    int cord__n_chars;

    int cord__eof_status;		/* whether we've seen an EOF on this buffer */
#define EOF_NOT_SEEN 0
    /* "pending" happens when the EOF has been seen but there's still
     * some text process
     */
#define EOF_PENDING 1
#define EOF_DONE 2
    };

static YY_BUFFER_STATE cord__current_buffer;

/* we provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state"
 */
#define YY_CURRENT_BUFFER cord__current_buffer


/* cord__hold_char holds the character lost when cord_text is formed */
static YY_CHAR cord__hold_char;

static int cord__n_chars;		/* number of characters read into cord__ch_buf */



#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

#ifndef YY_USER_INIT
#define YY_USER_INIT
#endif

extern YY_CHAR *cord_text;
extern int cord_leng;
extern FILE *cord_in, *cord_out;

YY_CHAR *cord_text;
int cord_leng;

FILE *cord_in = (FILE *) 0, *cord_out = (FILE *) 0;

#define YY_END_OF_BUFFER 45
typedef int cord__state_type;
static const short int cord__accept[371] =
    {   0,
        0,    0,   45,   39,   41,   43,   42,   42,   42,   39,
       42,   31,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       37,   41,   42,   37,   30,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   39,    0,   40,    0,   35,   34,   36,
       33,   31,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   39,   39,   39,   39,   39,   37,   37,    0,    0,
       30,    0,   38,   34,   33,   30,   37,   37,   37,   37,

       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       39,   33,   39,    0,   32,   39,   39,   28,   39,   20,
       39,   39,   39,   39,   39,   39,   39,   39,   39,   39,
       39,   27,   29,   39,   39,   39,   39,   39,    0,   38,
       37,   33,   37,   32,   37,   37,   28,   37,   20,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   37,   37,
       27,   29,   37,   37,   37,   37,   37,    0,   34,   39,
        0,   33,   32,   39,   39,   39,   39,   39,   39,   39,
       25,   39,   39,   39,    0,   16,    0,   17,   39,   39,

       39,   39,   39,   39,   39,   39,   34,   37,   33,   37,
       37,   37,   37,   37,   37,   37,   25,   37,   37,   37,
       37,   37,   37,   37,   37,   37,   37,   37,   34,    0,
       33,   33,   39,   39,   39,    0,   15,   39,   39,   22,
       39,   39,    0,   10,   21,   39,    0,    0,   39,   39,
       39,   39,   39,   39,   33,   37,   37,   37,   37,   37,
       22,   37,   37,   21,   37,   37,   37,   37,   37,   37,
       37,   33,   39,   39,   39,    0,    9,   39,    0,    2,
        0,    3,    0,   14,    0,    1,   39,    0,    0,    0,
       11,   39,   39,   39,   39,   39,   37,   37,   37,   37,

       37,   37,   37,   37,   37,   37,    0,   12,    0,   13,
       39,   39,    0,    5,    0,    0,   39,   39,   39,   39,
       39,   37,   37,   37,   37,   37,   37,   37,   24,   39,
        0,   19,   39,   39,    0,    6,    0,    7,    0,    8,
       24,   37,   37,   37,   39,    0,   23,   39,   37,   23,
       37,   39,    0,    0,    4,   37,    0,   18,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,   26,    0
    } ;

static const YY_CHAR cord__ec[128] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    1,    4,    5,    1,    1,    1,    1,    6,
        6,    7,    8,    6,    8,    9,   10,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,    1,    1,    1,
       12,    1,    1,    1,   13,   14,   15,   16,   17,   18,
       19,   20,   21,    1,   22,   23,   24,   25,   26,   27,
        1,   28,   29,   30,   31,    1,    1,   32,   33,   34,
        6,    1,    6,    1,    1,    1,   13,   14,   15,   16,

       17,   18,   19,   20,   21,    1,   22,   23,   24,   25,
       26,   27,    1,   28,   29,   30,   31,    1,    1,   32,
       33,   34,    1,    1,    1,    1,    1
    } ;

static const YY_CHAR cord__meta[35] =
    {   0,
        1,    2,    3,    2,    3,    3,    3,    3,    1,    3,
        1,    3,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1
    } ;

static const short int cord__base[378] =
    {   0,
        0,   34,  567,    0,  568,  568,  562,  562,  568,  553,
      556,   60,  537,  535,  534,  535,  533,  536,   53,  530,
      542,   59,   61,  523,  522,  531,   60,  526,  525,  524,
        0,   74,  544,  536,   78,  521,  519,  518,  519,  517,
      520,   62,  514,  526,   62,   71,  507,  506,  515,   78,
      510,  509,  508,    0,  528,  568,  528,  568,   82,  568,
       83,   92,   94,  511,  498,  499,  506,  510,  497,  499,
      502,  499,  494,  491,  494,  486,  492,  492,  492,  489,
      488,  489,  490,  479,  478,  477,    0,   94,  106,  503,
      109,  502,  568,  101,  104,  105,  115,  486,  473,  474,

      481,  485,  472,  474,  477,  474,  469,  466,  469,  461,
      467,  467,  467,  464,  463,  464,  465,  454,  453,  452,
      116,  108,  120,  471,  470,  100,  455,    0,  454,    0,
      449,  460,  460,  458,  447,  443,  455,  130,  132,  457,
      453,    0,    0,  448,  123,  444,  443,  442,  461,  568,
      129,  128,  130,  453,  119,  438,    0,  437,    0,  432,
      443,  443,  441,  430,  426,  438,  148,  150,  440,  436,
        0,    0,  431,  130,  427,  426,  425,  437,  436,  147,
      435,  434,  433,  416,  416,  425,  154,  410,  411,  409,
      408,  423,  161,  406,  165,  568,  167,  568,  417,  169,

      408,  407,  414,  416,  415,  414,  416,  167,  415,  398,
      398,  407,  180,  392,  393,  391,  390,  405,  182,  388,
      399,  184,  390,  389,  396,  398,  397,  396,  398,  397,
      396,  395,  390,  381,  390,  186,  568,  188,  389,  199,
      201,  203,  205,  568,  207,  373,  218,  220,  222,  381,
      370,  381,  380,  379,  384,  379,  370,  379,  224,  378,
      226,  229,  237,  242,  347,  244,  355,  344,  355,  354,
      353,  358,  248,  250,  340,  255,  568,  337,  261,  568,
      263,  568,  266,  568,  268,  568,  274,  279,  216,  281,
      568,  343,  345,  336,  332,  328,  285,  287,  326,  311,

      289,  316,  317,  307,  294,  292,  292,  568,  303,  568,
      285,  295,  305,  568,  278,  281,  281,  279,  307,  309,
      311,  252,  258,  257,  255,  322,  324,  326,    0,  235,
      242,  568,  226,  219,  328,  568,  330,  568,  341,  568,
        0,  209,  204,  189,  191,  201,    0,  343,  187,    0,
      345,  347,  171,  349,  568,  356,  360,  568,  180,  166,
      178,  152,  155,  147,  135,  140,  133,  121,  568,  568,
      106,  376,  379,   96,  382,  384,  387
    } ;

static const short int cord__def[378] =
    {   0,
      370,  370,  370,  371,  370,  370,  372,  373,  370,  371,
      370,  371,  371,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
      374,  375,  376,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  371,  372,  370,  373,  370,  371,  370,
      371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  371,  371,  374,  375,  375,  377,
      375,  376,  370,  374,  374,  374,  374,  374,  374,  374,

      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      371,  371,  371,  370,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  371,  371,  371,  371,  377,  370,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  370,  371,  371,
      370,  371,  370,  371,  371,  371,  371,  371,  371,  371,
      371,  371,  371,  371,  370,  370,  370,  370,  371,  371,

      371,  371,  371,  371,  371,  371,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  370,  370,
      371,  370,  371,  371,  371,  370,  370,  371,  371,  371,
      371,  371,  370,  370,  371,  371,  370,  370,  371,  371,
      371,  371,  371,  371,  374,  374,  374,  374,  374,  374,
      374,  374,  374,  374,  374,  374,  374,  374,  374,  374,
      374,  370,  371,  371,  371,  370,  370,  371,  370,  370,
      370,  370,  370,  370,  370,  370,  371,  370,  370,  370,
      370,  371,  371,  371,  371,  371,  374,  374,  374,  374,

      374,  374,  374,  374,  374,  374,  370,  370,  370,  370,
      371,  371,  370,  370,  370,  370,  371,  371,  371,  371,
      371,  374,  374,  374,  374,  374,  374,  374,  371,  371,
      370,  370,  371,  371,  370,  370,  370,  370,  370,  370,
      374,  374,  374,  374,  371,  370,  371,  371,  374,  374,
      374,  371,  370,  370,  370,  374,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,    0,
      370,  370,  370,  370,  370,  370,  370
    } ;

static const short int cord__nxt[603] =
    {   0,
        4,    5,    6,    7,    8,    9,    9,    9,   10,   11,
       12,    9,   13,   14,   15,   16,   17,   18,   19,   20,
        4,   21,   22,   23,   24,    4,    4,   25,   26,   27,
        4,   28,   29,   30,   31,   32,    6,   33,    8,    9,
        9,    9,   34,   11,   35,    9,   36,   37,   38,   39,
       40,   41,   42,   43,   31,   44,   45,   46,   47,   31,
       31,   48,   49,   50,   31,   51,   52,   53,   61,   70,
       62,   74,   81,   76,  108,   89,   63,   90,  104,   75,
       71,   77,  109,  110,   91,   82,   95,   83,   96,  105,
      115,  111,   59,  122,   97,  370,   87,  370,  121,  123,

       61,  124,   62,  116,  125,  117,   54,   89,   63,   90,
      370,   94,  370,   95,  152,   96,   91,  151,  122,   91,
      153,   97,  124,  178,  180,  154,  179,  181,  184,  185,
      182,  195,  195,  197,  197,  202,  178,  181,  152,  207,
      209,  196,  224,  198,  208,  369,  203,  210,  211,  195,
      195,  197,  197,  225,  230,  236,  236,  231,  368,  196,
      367,  198,  243,  243,  366,  237,  195,  195,  197,  197,
      247,  247,  244,  365,  230,  364,  196,  255,  198,  363,
      248,  236,  236,  243,  243,  247,  247,  236,  236,  276,
      276,  237,  362,  244,  361,  248,  360,  237,  358,  277,

      279,  279,  281,  281,  283,  283,  243,  243,  285,  285,
      280,  356,  282,  353,  284,  352,  244,  351,  286,  247,
      247,  288,  288,  290,  290,  276,  276,  279,  279,  248,
      281,  281,  350,  291,  349,  277,  315,  280,  283,  283,
      282,  316,  289,  285,  285,  290,  290,  348,  284,  307,
      307,  309,  309,  286,  347,  291,  276,  276,  346,  308,
      345,  310,  279,  279,  281,  281,  277,  283,  283,  285,
      285,  344,  280,  343,  282,  313,  313,  284,  342,  286,
      288,  288,  290,  290,  341,  314,  307,  307,  309,  309,
      313,  313,  291,  307,  307,  334,  308,  333,  310,  332,

      314,  289,  331,  308,  309,  309,  313,  313,  335,  335,
      337,  337,  339,  339,  310,  330,  314,  329,  336,  328,
      338,  327,  340,  335,  335,  337,  337,  339,  339,  335,
      335,  337,  337,  336,  326,  338,  325,  340,  324,  336,
      323,  338,  339,  339,  354,  354,  354,  354,  357,  357,
      354,  354,  340,  322,  355,  321,  355,  357,  357,  320,
      355,  357,  357,  319,  318,  317,  312,  311,  272,  306,
      305,  304,  303,  302,  301,  359,   55,   55,   55,   57,
       57,   57,   88,   88,   92,   92,   92,  149,  149,  149,
      300,  299,  298,  297,  255,  296,  295,  294,  293,  292,

      287,  278,  275,  274,  273,  232,  231,  272,  229,  271,
      270,  269,  268,  267,  266,  265,  264,  263,  262,  261,
      260,  259,  258,  257,  256,  209,  207,  254,  253,  252,
      251,  250,  249,  246,  245,  242,  241,  240,  239,  238,
      235,  234,  233,  183,  182,  232,  179,  229,  228,  227,
      226,  223,  222,  221,  220,  219,  218,  217,  216,  215,
      214,  213,  212,  154,  150,  206,  205,  204,  201,  200,
      199,  194,  193,  192,  191,  190,  189,  188,  187,  186,
      125,  183,  177,  176,  175,  174,  173,  172,  171,  170,
      169,  168,  167,  166,  165,  164,  163,  162,  161,  160,

      159,  158,  157,  156,  155,   93,  150,  148,  147,  146,
      145,  144,  143,  142,  141,  140,  139,  138,  137,  136,
      135,  134,  133,  132,  131,  130,  129,  128,  127,  126,
       58,   56,  120,  119,  118,  114,  113,  112,  107,  106,
      103,  102,  101,  100,   99,   98,   94,   93,   86,   85,
       84,   80,   79,   78,   73,   72,   69,   68,   67,   66,
       65,   64,   60,   59,   58,   56,  370,    3,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,

      370,  370
    } ;

static const short int cord__chk[603] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,   12,   19,
       12,   22,   27,   23,   45,   32,   12,   32,   42,   22,
       19,   23,   45,   46,   32,   27,   35,   27,   35,   42,
       50,   46,   59,   61,   35,   88,  374,   88,   59,   61,

       62,   63,   62,   50,   63,   50,  371,   89,   62,   89,
       91,   94,   91,   96,   95,   96,   89,   94,  122,   91,
       95,   96,   97,  121,  122,   97,  121,  123,  126,  126,
      123,  138,  138,  139,  139,  145,  151,  153,  152,  151,
      153,  138,  174,  139,  152,  368,  145,  155,  155,  167,
      167,  168,  168,  174,  180,  187,  187,  180,  367,  167,
      366,  168,  193,  193,  365,  187,  195,  195,  197,  197,
      200,  200,  193,  364,  208,  363,  195,  208,  197,  362,
      200,  213,  213,  219,  219,  222,  222,  236,  236,  238,
      238,  213,  361,  219,  360,  222,  359,  236,  353,  238,

      240,  240,  241,  241,  242,  242,  243,  243,  245,  245,
      240,  349,  241,  346,  242,  345,  243,  344,  245,  247,
      247,  248,  248,  249,  249,  259,  259,  261,  261,  247,
      262,  262,  343,  249,  342,  259,  289,  261,  263,  263,
      262,  289,  248,  264,  264,  266,  266,  334,  263,  273,
      273,  274,  274,  264,  333,  266,  276,  276,  331,  273,
      330,  274,  279,  279,  281,  281,  276,  283,  283,  285,
      285,  325,  279,  324,  281,  287,  287,  283,  323,  285,
      288,  288,  290,  290,  322,  287,  297,  297,  298,  298,
      301,  301,  290,  307,  307,  318,  297,  317,  298,  316,

      301,  288,  315,  307,  309,  309,  313,  313,  319,  319,
      320,  320,  321,  321,  309,  312,  313,  311,  319,  306,
      320,  305,  321,  326,  326,  327,  327,  328,  328,  335,
      335,  337,  337,  326,  304,  327,  303,  328,  302,  335,
      300,  337,  339,  339,  348,  348,  351,  351,  352,  352,
      354,  354,  339,  299,  348,  296,  351,  356,  356,  295,
      354,  357,  357,  294,  293,  292,  278,  275,  272,  271,
      270,  269,  268,  267,  265,  357,  372,  372,  372,  373,
      373,  373,  375,  375,  376,  376,  376,  377,  377,  377,
      260,  258,  257,  256,  255,  254,  253,  252,  251,  250,

      246,  239,  235,  234,  233,  232,  231,  230,  229,  228,
      227,  226,  225,  224,  223,  221,  220,  218,  217,  216,
      215,  214,  212,  211,  210,  209,  207,  206,  205,  204,
      203,  202,  201,  199,  194,  192,  191,  190,  189,  188,
      186,  185,  184,  183,  182,  181,  179,  178,  177,  176,
      175,  173,  170,  169,  166,  165,  164,  163,  162,  161,
      160,  158,  156,  154,  149,  148,  147,  146,  144,  141,
      140,  137,  136,  135,  134,  133,  132,  131,  129,  127,
      125,  124,  120,  119,  118,  117,  116,  115,  114,  113,
      112,  111,  110,  109,  108,  107,  106,  105,  104,  103,

      102,  101,  100,   99,   98,   92,   90,   86,   85,   84,
       83,   82,   81,   80,   79,   78,   77,   76,   75,   74,
       73,   72,   71,   70,   69,   68,   67,   66,   65,   64,
       57,   55,   53,   52,   51,   49,   48,   47,   44,   43,
       41,   40,   39,   38,   37,   36,   34,   33,   30,   29,
       28,   26,   25,   24,   21,   20,   18,   17,   16,   15,
       14,   13,   11,   10,    8,    7,    3,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,
      370,  370,  370,  370,  370,  370,  370,  370,  370,  370,

      370,  370
    } ;

static cord__state_type cord__last_accepting_state;
static YY_CHAR *cord__last_accepting_cpos;

/* the intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed
 */
#define REJECT reject_used_but_not_detected
#define cord_more() cord_more_used_but_not_detected
#define YY_MORE_ADJ 0

/* these variables are all declared out here so that section 3 code can
 * manipulate them
 */
/* points to current character in buffer */
static YY_CHAR *cord__c_buf_p = (YY_CHAR *) 0;
static int cord__init = 1;		/* whether we need to initialize */
static int cord__start = 0;	/* start state number */

/* flag which is used to allow cord_wrap()'s to do buffer switches
 * instead of setting up a fresh cord_in.  A bit of a hack ...
 */
static int cord__did_buffer_switch_on_eof;

static cord__state_type cord__get_previous_state YY_PROTO(( void ));
static cord__state_type cord__try_NUL_trans YY_PROTO(( cord__state_type current_state ));
static int cord__get_next_buffer YY_PROTO(( void ));
static void cord_unput YY_PROTO(( YY_CHAR c, YY_CHAR *buf_ptr ));
void cord_restart YY_PROTO(( FILE *input_file ));
void cord__switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void cord__load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE cord__create_buffer YY_PROTO(( FILE *file, int size ));
void cord__delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void cord__init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));

#define cord__new_buffer cord__create_buffer

#ifdef __cplusplus
static int cord_input YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif

YY_DECL
    {
    register cord__state_type cord__current_state;
    register YY_CHAR *cord__cp, *cord__bp;
    register int cord__act;




    if ( cord__init )
	{
	YY_USER_INIT;

	if ( ! cord__start )
	    cord__start = 1;	/* first start state */

	if ( ! cord_in )
	    cord_in = stdin;

	if ( ! cord_out )
	    cord_out = stdout;

	if ( cord__current_buffer )
	    cord__init_buffer( cord__current_buffer, cord_in );
	else
	    cord__current_buffer = cord__create_buffer( cord_in, YY_BUF_SIZE );

	cord__load_buffer_state();

	cord__init = 0;
	}

    while ( 1 )		/* loops until end-of-file is reached */
	{
	cord__cp = cord__c_buf_p;

	/* support of cord_text */
	*cord__cp = cord__hold_char;

	/* cord__bp points to the position in cord__ch_buf of the start of the
	 * current run.
	 */
	cord__bp = cord__cp;

	cord__current_state = cord__start;
	if ( cord__bp[-1] == '\n' )
	    ++cord__current_state;
cord__match:
	do
	    {
	    register YY_CHAR cord__c = cord__ec[*cord__cp];
	    if ( cord__accept[cord__current_state] )
		{
		cord__last_accepting_state = cord__current_state;
		cord__last_accepting_cpos = cord__cp;
		}
	    while ( cord__chk[cord__base[cord__current_state] + cord__c] != cord__current_state )
		{
		cord__current_state = cord__def[cord__current_state];
		if ( cord__current_state >= 371 )
		    cord__c = cord__meta[cord__c];
		}
	    cord__current_state = cord__nxt[cord__base[cord__current_state] + cord__c];
	    ++cord__cp;
	    }
	while ( cord__current_state != 370 );
	cord__cp = cord__last_accepting_cpos;
	cord__current_state = cord__last_accepting_state;

cord__find_action:
	cord__act = cord__accept[cord__current_state];

	YY_DO_BEFORE_ACTION;
	YY_USER_ACTION;

do_action:	/* this label is used only to access EOF actions */


	switch ( cord__act )
	    {
	    case 0: /* must backtrack */
	    /* undo the effects of YY_DO_BEFORE_ACTION */
	    *cord__cp = cord__hold_char;
	    cord__cp = cord__last_accepting_cpos;
	    cord__current_state = cord__last_accepting_state;
	    goto cord__find_action;


/* Assignments */

case 1:
# line 73 "lexer.l"
{return LINES_EQ;}
	YY_BREAK
case 2:
# line 74 "lexer.l"
{return GRIDS_EQ;}
	YY_BREAK
case 3:
# line 75 "lexer.l"
{return HOLES_EQ;}
	YY_BREAK
case 4:
# line 76 "lexer.l"
{return TRIANGLES_EQ;}
	YY_BREAK
case 5:
# line 77 "lexer.l"
{return NUMBER_EQ;}
	YY_BREAK
case 6:
# line 78 "lexer.l"
{return XNUMBER_EQ;}
	YY_BREAK
case 7:
# line 79 "lexer.l"
{return YNUMBER_EQ;}
	YY_BREAK
case 8:
# line 80 "lexer.l"
{return ZNUMBER_EQ;}
	YY_BREAK
case 9:
# line 81 "lexer.l"
{return FIRST_EQ;}
	YY_BREAK
case 10:
# line 82 "lexer.l"
{return LAST_EQ;}
	YY_BREAK
case 11:
# line 83 "lexer.l"
{return TOLIN_EQ;}
	YY_BREAK
case 12:
# line 84 "lexer.l"
{return ANGSPC_EQ;}
	YY_BREAK
case 13:
# line 85 "lexer.l"
{return ANGTOL_EQ;}
	YY_BREAK
case 14:
# line 86 "lexer.l"
{return KAPPA_EQ;}
	YY_BREAK
case 15:
# line 87 "lexer.l"
{return DMIN_EQ;}
	YY_BREAK
case 16:
# line 88 "lexer.l"
{return MAX_EQ;}
	YY_BREAK
case 17:
# line 89 "lexer.l"
{return MIN_EQ;}
	YY_BREAK
case 18:
# line 90 "lexer.l"
{cord_lval.i = 'i'; return RULE_EQ;}
	YY_BREAK
case 19:
# line 91 "lexer.l"
{cord_lval.i = 'o'; return RULE_EQ;}
	YY_BREAK

/* Keywords */

case 20:
# line 98 "lexer.l"
{return END;}
	YY_BREAK
case 21:
# line 99 "lexer.l"
{return LINES;}
	YY_BREAK
case 22:
# line 100 "lexer.l"
{return GRIDS;}
	YY_BREAK
case 23:
# line 101 "lexer.l"
{return TRIANGLE;}
	YY_BREAK
case 24:
# line 102 "lexer.l"
{return BOUNDARY;}
	YY_BREAK
case 25:
# line 103 "lexer.l"
{return HOLE;}
	YY_BREAK
case 26:
# line 104 "lexer.l"
{return PROBLEM;}
	YY_BREAK

/* Functions */

case 27:
# line 111 "lexer.l"
{return SIN;}
	YY_BREAK
case 28:
# line 112 "lexer.l"
{return COS;}
	YY_BREAK
case 29:
# line 113 "lexer.l"
{return TAN;}
	YY_BREAK

/* Numbers */

case 30:
# line 119 "lexer.l"
{cord_lval.i = atoi (cord_text); return BOLINTEGER;}
	YY_BREAK
case 31:
# line 120 "lexer.l"
{cord_lval.i = atoi (cord_text); return INTEGER;}
	YY_BREAK
case 32:
# line 121 "lexer.l"
{cord_lval.d = atof (cord_text); return DOUBLE;}
	YY_BREAK
case 33:
# line 122 "lexer.l"
{cord_lval.d = atof (cord_text); return DOUBLE;}
	YY_BREAK
case 34:
# line 123 "lexer.l"
{cord_lval.d = atof (cord_text); return DOUBLE;}
	YY_BREAK

/* Comments or remaining preprocessor lines */

case 35:
*cord__cp = cord__hold_char; /* undo effects of setting up cord_text */
cord__c_buf_p = cord__cp -= 1;
YY_DO_BEFORE_ACTION; /* set up cord_text again */
# line 130 "lexer.l"
{}
	YY_BREAK
case 36:
# line 131 "lexer.l"
{char c;
			 	 while (1) {
				    while ((c = input ( )) != '*' && c > 0);
				    if (c <= 0 || (c = input ( )) == '/')
					break;
				    unput (c);
				 }}
	YY_BREAK

/* Strings and single characters */

case 37:
# line 144 "lexer.l"
{cord_lval.s = strdup (cord_text); return BOLSTRING;}
	YY_BREAK
case 38:
# line 145 "lexer.l"
{cord_lval.s = strdup (cord_text + 1);
				 cord_lval.s [cord_leng - 2] = 0; return BOLSTRING;}
	YY_BREAK
case 39:
# line 148 "lexer.l"
{cord_lval.s = strdup (cord_text); return STRING;}
	YY_BREAK
case 40:
# line 149 "lexer.l"
{cord_lval.s = strdup (cord_text + 1);
				 cord_lval.s [cord_leng - 2] = 0; return STRING;}
	YY_BREAK
case 41:
# line 152 "lexer.l"
{}
	YY_BREAK
case 42:
# line 153 "lexer.l"
{return *cord_text;}
	YY_BREAK
case 43:
# line 154 "lexer.l"
{generator.line ++;}
	YY_BREAK
case 44:
# line 155 "lexer.l"
ECHO;
	YY_BREAK
case YY_STATE_EOF(INITIAL):
    cord_terminate();

	    case YY_END_OF_BUFFER:
		{
		/* amount of text matched not including the EOB char */
		int cord__amount_of_matched_text = cord__cp - cord_text - 1;

		/* undo the effects of YY_DO_BEFORE_ACTION */
		*cord__cp = cord__hold_char;

		/* note that here we test for cord__c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since cord__c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the end-
		 * of-buffer state).  Contrast this with the test in cord_input().
		 */
		if ( cord__c_buf_p <= &cord__current_buffer->cord__ch_buf[cord__n_chars] )
		    /* this was really a NUL */
		    {
		    cord__state_type cord__next_state;

		    cord__c_buf_p = cord_text + cord__amount_of_matched_text;

		    cord__current_state = cord__get_previous_state();

		    /* okay, we're now positioned to make the
		     * NUL transition.  We couldn't have
		     * cord__get_previous_state() go ahead and do it
		     * for us because it doesn't know how to deal
		     * with the possibility of jamming (and we
		     * don't want to build jamming into it because
		     * then it will run more slowly)
		     */

		    cord__next_state = cord__try_NUL_trans( cord__current_state );

		    cord__bp = cord_text + YY_MORE_ADJ;

		    if ( cord__next_state )
			{
			/* consume the NUL */
			cord__cp = ++cord__c_buf_p;
			cord__current_state = cord__next_state;
			goto cord__match;
			}

		    else
			{
			    cord__cp = cord__last_accepting_cpos;
			    cord__current_state = cord__last_accepting_state;
			goto cord__find_action;
			}
		    }

		else switch ( cord__get_next_buffer() )
		    {
		    case EOB_ACT_END_OF_FILE:
			{
			cord__did_buffer_switch_on_eof = 0;

			if ( cord_wrap() )
			    {
			    /* note: because we've taken care in
			     * cord__get_next_buffer() to have set up cord_text,
			     * we can now set up cord__c_buf_p so that if some
			     * total hoser (like flex itself) wants
			     * to call the scanner after we return the
			     * YY_NULL, it'll still work - another YY_NULL
			     * will get returned.
			     */
			    cord__c_buf_p = cord_text + YY_MORE_ADJ;

			    cord__act = YY_STATE_EOF((cord__start - 1) / 2);
			    goto do_action;
			    }

			else
			    {
			    if ( ! cord__did_buffer_switch_on_eof )
				YY_NEW_FILE;
			    }
			}
			break;

		    case EOB_ACT_CONTINUE_SCAN:
			cord__c_buf_p = cord_text + cord__amount_of_matched_text;

			cord__current_state = cord__get_previous_state();

			cord__cp = cord__c_buf_p;
			cord__bp = cord_text + YY_MORE_ADJ;
			goto cord__match;

		    case EOB_ACT_LAST_MATCH:
			cord__c_buf_p =
			    &cord__current_buffer->cord__ch_buf[cord__n_chars];

			cord__current_state = cord__get_previous_state();

			cord__cp = cord__c_buf_p;
			cord__bp = cord_text + YY_MORE_ADJ;
			goto cord__find_action;
		    }
		break;
		}

	    default:
#ifdef FLEX_DEBUG
		printf( "action # %d\n", cord__act );
#endif
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	    }
	}
    }


/* cord__get_next_buffer - try to read in a new buffer
 *
 * synopsis
 *     int cord__get_next_buffer();
 *     
 * returns a code representing an action
 *     EOB_ACT_LAST_MATCH - 
 *     EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *     EOB_ACT_END_OF_FILE - end of file
 */

static int cord__get_next_buffer()

    {
    register YY_CHAR *dest = cord__current_buffer->cord__ch_buf;
    register YY_CHAR *source = cord_text - 1; /* copy prev. char, too */
    register int number_to_move, i;
    int ret_val;

    if ( cord__c_buf_p > &cord__current_buffer->cord__ch_buf[cord__n_chars + 1] )
	YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

    /* try to read more data */

    /* first move last chars to start of buffer */
    number_to_move = cord__c_buf_p - cord_text;

    for ( i = 0; i < number_to_move; ++i )
	*(dest++) = *(source++);

    if ( cord__current_buffer->cord__eof_status != EOF_NOT_SEEN )
	/* don't do the read, it's not guaranteed to return an EOF,
	 * just force an EOF
	 */
	cord__n_chars = 0;

    else
	{
	int num_to_read = cord__current_buffer->cord__buf_size - number_to_move - 1;

	if ( num_to_read > YY_READ_BUF_SIZE )
	    num_to_read = YY_READ_BUF_SIZE;

	else if ( num_to_read <= 0 )
	    YY_FATAL_ERROR( "fatal error - scanner input buffer overflow" );

	/* read in more data */
	YY_INPUT( (&cord__current_buffer->cord__ch_buf[number_to_move]),
		  cord__n_chars, num_to_read );
	}

    if ( cord__n_chars == 0 )
	{
	if ( number_to_move == 1 )
	    {
	    ret_val = EOB_ACT_END_OF_FILE;
	    cord__current_buffer->cord__eof_status = EOF_DONE;
	    }

	else
	    {
	    ret_val = EOB_ACT_LAST_MATCH;
	    cord__current_buffer->cord__eof_status = EOF_PENDING;
	    }
	}

    else
	ret_val = EOB_ACT_CONTINUE_SCAN;

    cord__n_chars += number_to_move;
    cord__current_buffer->cord__ch_buf[cord__n_chars] = YY_END_OF_BUFFER_CHAR;
    cord__current_buffer->cord__ch_buf[cord__n_chars + 1] = YY_END_OF_BUFFER_CHAR;

    /* cord_text begins at the second character in cord__ch_buf; the first
     * character is the one which preceded it before reading in the latest
     * buffer; it needs to be kept around in case it's a newline, so
     * cord__get_previous_state() will have with '^' rules active
     */

    cord_text = &cord__current_buffer->cord__ch_buf[1];

    return ( ret_val );
    }


/* cord__get_previous_state - get the state just before the EOB char was reached
 *
 * synopsis
 *     cord__state_type cord__get_previous_state();
 */

static cord__state_type cord__get_previous_state()

    {
    register cord__state_type cord__current_state;
    register YY_CHAR *cord__cp;

    register YY_CHAR *cord__bp = cord_text;

    cord__current_state = cord__start;
    if ( cord__bp[-1] == '\n' )
	++cord__current_state;

    for ( cord__cp = cord_text + YY_MORE_ADJ; cord__cp < cord__c_buf_p; ++cord__cp )
	{
	register YY_CHAR cord__c = (*cord__cp ? cord__ec[*cord__cp] : 1);
	if ( cord__accept[cord__current_state] )
	    {
	    cord__last_accepting_state = cord__current_state;
	    cord__last_accepting_cpos = cord__cp;
	    }
	while ( cord__chk[cord__base[cord__current_state] + cord__c] != cord__current_state )
	    {
	    cord__current_state = cord__def[cord__current_state];
	    if ( cord__current_state >= 371 )
		cord__c = cord__meta[cord__c];
	    }
	cord__current_state = cord__nxt[cord__base[cord__current_state] + cord__c];
	}

    return ( cord__current_state );
    }


/* cord__try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *     next_state = cord__try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static cord__state_type cord__try_NUL_trans( register cord__state_type cord__current_state )
#else
static cord__state_type cord__try_NUL_trans( cord__current_state )
register cord__state_type cord__current_state;
#endif

    {
    register int cord__is_jam;
    register YY_CHAR *cord__cp = cord__c_buf_p;

    register YY_CHAR cord__c = 1;
    if ( cord__accept[cord__current_state] )
	{
	cord__last_accepting_state = cord__current_state;
	cord__last_accepting_cpos = cord__cp;
	}
    while ( cord__chk[cord__base[cord__current_state] + cord__c] != cord__current_state )
	{
	cord__current_state = cord__def[cord__current_state];
	if ( cord__current_state >= 371 )
	    cord__c = cord__meta[cord__c];
	}
    cord__current_state = cord__nxt[cord__base[cord__current_state] + cord__c];
    cord__is_jam = (cord__current_state == 370);

    return ( cord__is_jam ? 0 : cord__current_state );
    }


#ifdef YY_USE_PROTOS
static void cord_unput( YY_CHAR c, register YY_CHAR *cord__bp )
#else
static void cord_unput( c, cord__bp )
YY_CHAR c;
register YY_CHAR *cord__bp;
#endif

    {
    register YY_CHAR *cord__cp = cord__c_buf_p;

    /* undo effects of setting up cord_text */
    *cord__cp = cord__hold_char;

    if ( cord__cp < cord__current_buffer->cord__ch_buf + 2 )
	{ /* need to shift things up to make room */
	register int number_to_move = cord__n_chars + 2; /* +2 for EOB chars */
	register YY_CHAR *dest =
	    &cord__current_buffer->cord__ch_buf[cord__current_buffer->cord__buf_size + 2];
	register YY_CHAR *source =
	    &cord__current_buffer->cord__ch_buf[number_to_move];

	while ( source > cord__current_buffer->cord__ch_buf )
	    *--dest = *--source;

	cord__cp += dest - source;
	cord__bp += dest - source;
	cord__n_chars = cord__current_buffer->cord__buf_size;

	if ( cord__cp < cord__current_buffer->cord__ch_buf + 2 )
	    YY_FATAL_ERROR( "flex scanner push-back overflow" );
	}

    if ( cord__cp > cord__bp && cord__cp[-1] == '\n' )
	cord__cp[-2] = '\n';

    *--cord__cp = c;

    /* note: the formal parameter *must* be called "cord__bp" for this
     *       macro to now work correctly
     */
    YY_DO_BEFORE_ACTION; /* set up cord_text again */
    }


#ifdef __cplusplus
static int cord_input()
#else
static int input()
#endif

    {
    int c;
    YY_CHAR *cord__cp = cord__c_buf_p;

    *cord__cp = cord__hold_char;

    if ( *cord__c_buf_p == YY_END_OF_BUFFER_CHAR )
	{
	/* cord__c_buf_p now points to the character we want to return.
	 * If this occurs *before* the EOB characters, then it's a
	 * valid NUL; if not, then we've hit the end of the buffer.
	 */
	if ( cord__c_buf_p < &cord__current_buffer->cord__ch_buf[cord__n_chars] )
	    /* this was really a NUL */
	    *cord__c_buf_p = '\0';

	else
	    { /* need more input */
	    cord_text = cord__c_buf_p;
	    ++cord__c_buf_p;

	    switch ( cord__get_next_buffer() )
		{
		case EOB_ACT_END_OF_FILE:
		    {
		    if ( cord_wrap() )
			{
			cord__c_buf_p = cord_text + YY_MORE_ADJ;
			return ( EOF );
			}

		    YY_NEW_FILE;

#ifdef __cplusplus
		    return ( cord_input() );
#else
		    return ( input() );
#endif
		    }
		    break;

		case EOB_ACT_CONTINUE_SCAN:
		    cord__c_buf_p = cord_text + YY_MORE_ADJ;
		    break;

		case EOB_ACT_LAST_MATCH:
#ifdef __cplusplus
		    YY_FATAL_ERROR( "unexpected last match in cord_input()" );
#else
		    YY_FATAL_ERROR( "unexpected last match in input()" );
#endif
		}
	    }
	}

    c = *cord__c_buf_p;
    cord__hold_char = *++cord__c_buf_p;

    return ( c );
    }


#ifdef YY_USE_PROTOS
void cord_restart( FILE *input_file )
#else
void cord_restart( input_file )
FILE *input_file;
#endif

    {
    cord__init_buffer( cord__current_buffer, input_file );
    cord__load_buffer_state();
    }


#ifdef YY_USE_PROTOS
void cord__switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void cord__switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif

    {
    if ( cord__current_buffer == new_buffer )
	return;

    if ( cord__current_buffer )
	{
	/* flush out information for old buffer */
	*cord__c_buf_p = cord__hold_char;
	cord__current_buffer->cord__buf_pos = cord__c_buf_p;
	cord__current_buffer->cord__n_chars = cord__n_chars;
	}

    cord__current_buffer = new_buffer;
    cord__load_buffer_state();

    /* we don't actually know whether we did this switch during
     * EOF (cord_wrap()) processing, but the only time this flag
     * is looked at is after cord_wrap() is called, so it's safe
     * to go ahead and always set it.
     */
    cord__did_buffer_switch_on_eof = 1;
    }


#ifdef YY_USE_PROTOS
void cord__load_buffer_state( void )
#else
void cord__load_buffer_state()
#endif

    {
    cord__n_chars = cord__current_buffer->cord__n_chars;
    cord_text = cord__c_buf_p = cord__current_buffer->cord__buf_pos;
    cord_in = cord__current_buffer->cord__input_file;
    cord__hold_char = *cord__c_buf_p;
    }


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE cord__create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE cord__create_buffer( file, size )
FILE *file;
int size;
#endif

    {
    YY_BUFFER_STATE b;

    b = (YY_BUFFER_STATE) malloc( sizeof( struct cord__buffer_state ) );

    if ( ! b )
	YY_FATAL_ERROR( "out of dynamic memory in cord__create_buffer()" );

    b->cord__buf_size = size;

    /* cord__ch_buf has to be 2 characters longer than the size given because
     * we need to put in 2 end-of-buffer characters.
     */
    b->cord__ch_buf = (YY_CHAR *) malloc( (unsigned) (b->cord__buf_size + 2) );

    if ( ! b->cord__ch_buf )
	YY_FATAL_ERROR( "out of dynamic memory in cord__create_buffer()" );

    cord__init_buffer( b, file );

    return ( b );
    }


#ifdef YY_USE_PROTOS
void cord__delete_buffer( YY_BUFFER_STATE b )
#else
void cord__delete_buffer( b )
YY_BUFFER_STATE b;
#endif

    {
    if ( b == cord__current_buffer )
	cord__current_buffer = (YY_BUFFER_STATE) 0;

    free( (char *) b->cord__ch_buf );
    free( (char *) b );
    }


#ifdef YY_USE_PROTOS
void cord__init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void cord__init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif

    {
    b->cord__input_file = file;

    /* we put in the '\n' and start reading from [1] so that an
     * initial match-at-newline will be true.
     */

    b->cord__ch_buf[0] = '\n';
    b->cord__n_chars = 1;

    /* we always need two end-of-buffer characters.  The first causes
     * a transition to the end-of-buffer state.  The second causes
     * a jam in that state.
     */
    b->cord__ch_buf[1] = YY_END_OF_BUFFER_CHAR;
    b->cord__ch_buf[2] = YY_END_OF_BUFFER_CHAR;

    b->cord__buf_pos = &b->cord__ch_buf[1];

    b->cord__eof_status = EOF_NOT_SEEN;
    }
# line 155 "lexer.l"



/************************************************************************
 * Function:	 cord_error						*
 *									*
 * Parameters:	 msg - error message					*
 *									*
 * Return value: none							*
 *									*
 * Calls:	 none							*
 *									*
 * Called by:	 cord_parse						*
 *									*
 * Global data:	 cord_text and cord_char are used				*
 *		 generator is modified					*
 *									*
 * Description:	 Yyerror is used to write an error message when a	*
 *		 syntax error occurs.					*
 ************************************************************************/

void cord_error (msg)
    char *msg;
{
    extern int cord_char;


    if (cord_char)
	error ("%s (%s unexpected near line %d)", msg, cord_text, generator.line);
    else
	error ("%s (end of input unexpected)", msg);

    generator.numerrors ++;
}


/************************************************************************
 * Function:	 RestartLexer						*
 *									*
 * Parameters:	 fp - pointer to input stream				*
 *									*
 * Return value: none							*
 *									*
 * Calls:	 none							*
 *									*
 * Called by:	 GetProblem						*
 *									*
 * Global data:	 generator is partially initialized			*
 *									*
 * Description:	 RestartLexer restarts the lexical analyzer by		*
 *		 initializing the file pointer.				*
 ************************************************************************/

void RestartLexer (fp)
    FILE *fp;
{
    static int firsttime = 1;

# ifdef FLEX_SCANNER
    if (!firsttime)
	cord_restart (fp);
    else {
	firsttime = 0;
	cord_in = fp;
    }
# else
    cord_in = fp;
# endif

    generator.numlines = 0;
    generator.numgrids = 0;
    generator.numtrimeshes = 0;
    generator.line = 0;
}

# undef cord_wrap
int cord_wrap ( ) {return 1;}
